import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:karte_variables/karte_variables.dart';

void main() {
  const MethodChannel channel = MethodChannel('karte_variables');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return Variable("test");
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    var variable = await Variables.get("test");
    expect(variable.name, "test");
  });
}
